function E=AC_modulus(Tref,maat,mixparam,time,t,Hac)

% Returns effective AC-modulus at the end of 20 years

% inputs in modulus estimation

p34=mixparam(1); p38=mixparam(2); p4=mixparam(3); p200=mixparam(4); 
Va=mixparam(5); Vbeff=mixparam(6); A=mixparam(7); VTS=mixparam(8);

% Dynamic modulus mater curve parameters 

% delta=
% alpha=  
gama=0.37217;

% time of loading
logt = log10(t);
gamat=gama*logt;

% depth at which modulus is calculated
% z=[];



for i=1:length(z)
    

Vaged=agingf(A,VTS,Tref,maat,time,z(i));
beta=-0.513574-0.355353*log10(Vaged);

% Calculating dynamic modulus at a given depth and time of loading

E(i)=10^(delta+alpha/(1+exp(beta+gamat)));  % in psi


end
