%l=87;
function j1=besj1(l,m,a);

% BESSEL J1(ma)

for  i=1:l;
    mai=m*a(i);
    if(mai>16.)
        j1(i)=sin(mai-pi/4)*sqrt(2/pi/mai);
    else
        z9=0.;
        v1=1.;
        v2=1.;
        while(abs(v2)>0.00001)
            z9=z9+1.; 
            v2=-v2/z9*(mai/2)^2/(z9+1);
            v1=v1+v2;
        end
        j1(i)=mai*v1/2;
    end
end  



