
function ccou1(l,l1,ls,xc,xs,yc,ys,zs,a,p,u1,e1);

%  complement of values in the first layer

global res;

y=zeros(1,9);
f=zeros(1,6);
n=500.;

for i=1:l1;
    
    if(ls(i)==1 & zs(i)~= 0.)
    
        res(i,1)=res(i,1)*(1.+u1)/e1;
        res(i,2)=-res(i,2)*(1.+u1)/e1;
        res(i,3)=-res(i,3)*(1.+u1)/e1;
        
        for j=1:l
            
            r=sqrt((xc(j)-xs(i))^2+(yc(j)-ys(i))^2);
            alpha=0.;
            if(xc(j)~=xs(i) | yc(j)~=ys(i))
                alpha=atan2(ys(i)-yc(j),xs(i)-xc(j)); 
            end

            y(1:9)=0.;
            
            if(r==0.)
                y(6)=(sqrt(a(j)^2+zs(i)^2)-zs(i))*p(j);
                y(1)=y(6)/sqrt(a(j)^2+zs(i)^2);
                y(2)=p(j)*a(j)^2*zs(i)/sqrt((a(j)^2+zs(i)^2)^3);
                y(3)=y(1)/2.;
                y(4)=y(2)/2.;
                y(7)=y(1)*zs(i);
            else
                pas1=2.*a(j)/n;
                pas2=pi/n;
                x1=-a(j);
                x2=0.;
                w1=0;
                
                kk=0;
                while(kk==0)
                    x1=x1+pas1;
                    x2=x2+pas2;
                    if(x1<=(a(j)-pas1/2))
                        f(1)=fonc1(x1,zs(i),a(j),r);
                        f(2)=fonc2(x1,zs(i),a(j),r);
                        f(3)=fonc3(x2,zs(i),a(j),r);
                        f(4)=fonc4(x2,zs(i),a(j),r);
                        f(5)=fonc5(x2,zs(i),a(j),r);
                        f(6)=fonc6(x1,zs(i),a(j),r);
                        if(w1==0)
                            f=4.*f;
                            w1=1;
                        else
                            f=2.*f;
                            w1=0;
                        end
                        y(1:6)=y(1:6)+f(1:6);
                    else
                        kk==1;
                    end
                end
                
                y(1)=p(j)*(y(1)*pas1/3)/(2*pi);
                y(2)=p(j)*(y(2)*pas1/3)/(2*pi)+y(1);
                y(3)=p(j)*(y(3)*pas2/3)*(a(j)^2/pi);
                y(4)=p(j)*(y(4)*pas2/3)*(a(j)^2*zs(i)/pi);
                y(5)=p(j)*(y(5)*pas2/3)*(3*a(j)^2*r*zs(i)^2/pi);
                y(6)=p(j)*(y(6)*pas1/3)/(2*pi);
                y(7)=y(1)*zs(i);
                y(8)=y(3)*r;
                y(9)=y(4)*r;
            end
            
            res(i,1)=res(i,1)-y(6)*2.*(1.-u1*u1)/e1-y(7)*(1.+u1)/e1;
            c=y(1)*(1.+2.*u1)/2.-y(2)/2.;
            
            if(r~=0.)
                d=(y(1)/2.-y(3))*(1.-2.*u1)-y(2)/2.+y(4);
                res(i,4)=res(i,4)+c+d*cos(2.*alpha);
                res(i,5)=res(i,5)+c-d*cos(2.*alpha);
                res(i,9)=res(i,9)+d*sin(2.*alpha);
                c=y(8)*(1.-2.*u1)*(1.+u1)/e1-y(9)*(1.+u1)/e1;
                res(i,2)=res(i,2)+c*cos(alpha);
                res(i,3)=res(i,3)+c*sin(alpha);
                res(i,8)=res(i,8)+y(5)*cos(alpha);
                res(i,7)=res(i,7)+y(5)*sin(alpha);
            else
                res(i,4)=res(i,4)+c;
                res(i,5)=res(i,5)+c;
            end
            res(i,6)=res(i,6)+y(1)+y(2);
            
        end
        
    end
    
end
            
% ---------------------------------------------------------------------

function fonc1Result=fonc1(x,z,a,r)   
fonc1Result=2.*z*sqrt(a^2-x^2)/((z^2+x^2+r^2-2.*x*r)*...
    sqrt(z^2+r^2+a^2-2.*x*r));

function fonc2Result=fonc2(x,z,a,r)
a1=z*z+x*x+r*r-2.*x*r;
a2=z*z+a*a+r*r-2.*x*r;
fonc2Result=-(2.*z*(r*r+x*x-2.*r*x)*sqrt(a*a-x*x))*(1./a2+2./a1)...
    /(a1*sqrt(a2));
fonc2Result=fonc2Result+2.*z*sqrt(a*a-x*x)/(sqrt(a2^3));

function fonc3Result=fonc3(x,z,a,r)
omega=sqrt(a*a+r*r-2.*a*r*cos(x));
fonc3Result=(sin(x)^2)*(1.-z/sqrt(omega^2+z*z))/omega^2;

function fonc4Result=fonc4(x,z,a,r)
omega=sqrt(a*a+r*r-2.*a*r*cos(x));
fonc4Result=(sin(x)^2)/sqrt((omega^2+z*z)^3);

function fonc5Result=fonc5(x,z,a,r);
omega=sqrt(a*a+r*r-2.*a*r*cos(x));
fonc5Result=(sin(x)^2)/sqrt((omega^2+z*z)^5);

function fonc6Result=fonc6(x,z,a,r);
a1=sqrt(r*r-2.*x*r+a*a+z*z);
a2=sqrt(a*a-x*x);
fonc6Result=log((a1+a2)/(a1-a2));

