
function comsu(l,l1,a,p,u1,e1,xc,xs,yc,ys,zs);

%  complement of surface values   

global prov;
global res;

for i=1:l1
    
    if(zs(i)==0.)
        res(i,1)=res(i,1)*(4.*(1.-u1*u1)/e1);
        res(i,2)=res(i,2)*(-4.*(1.-u1*u1)/e1);
        res(i,3)=res(i,3)*(-4.*(1.-u1*u1)/e1);
        res(i,6)=0.;
        res(i,7)=0.;
        res(i,8)=0.;
        for j=1:l
            r=sqrt((xc(j)-xs(i))^2+(yc(j)-ys(i))^2);
            alpha=0.;
            if(xc(j)~=xs(i) | yc(j)~=ys(i))
                alpha=atan2(ys(i)-yc(j),xs(i)-xc(j)); 
            end
            if(r<a(j))
                b=-0.5;
                c=1.;
                z=(r/a(j))^2;
                res(i,1)=res(i,1)-2.*(1.-u1*u1)*p(j)*a(j)*fonc(b,c,z)/e1;
                if(r~= 0.)
                    c=(1.+u1)*(1.-2.*u1)*p(j)*r/(2.*e1);
                    res(i,2)=res(i,2)+c*cos(alpha);
                    res(i,3)=res(i,3)+c*sin(alpha);
                end
                res(i,4)=res(i,4)+(1.+2.*u1)*p(j)/2;
                res(i,5)=res(i,5)+(1.+2.*u1)*p(j)/2;
                res(i,6)=res(i,6)+p(j);
            else
                if(r==a(j))
                    res(i,1)=res(i,1)-2.*(1.-u1*u1)*p(j)*a(j)*2./(pi*e1);
                    c=(1.+u1)*(1.-2.*u1)*p(j)*a(j)/(2.*e1);
                    res(i,2)=res(i,2)+c*cos(alpha);
                    res(i,3)=res(i,3)+c*sin(alpha);
                    c=(1.+2.*u1)*p(j)/4.;
                    d=-(1.-2.*u1)*p(j)/4.;
                    res(i,4)=res(i,4)+c+d*cos(2.*alpha);
                    res(i,5)=res(i,5)+c-d*cos(2.*alpha);
                    res(i,9)=res(i,9)+d*sin(2.*alpha);
                    res(i,6)=res(i,6)+p(j)/2.;
                else
                    b=0.5;
                    c=2.;
                    z=(a(j)/r)^2;
                    res(i,1)=res(i,1)-2.*(1.-u1*u1)*p(j)*a(j)*fonc(b,c,z)...
                        *a(j)/(2.*r*e1);
                    c=(1.+u1)*(1.-2.*u1)*p(j)*a(j)^2/(2.*r*e1);
                    res(i,2)=res(i,2)+c*cos(alpha);
                    res(i,3)=res(i,3)+c*sin(alpha);
                    d=-(1.-2.*u1)*p(j)*a(j)*a(j)/(r*r*2);
                    res(i,4)=res(i,4)+d*cos(2.*alpha);
                    res(i,5)=res(i,5)-d*cos(2.*alpha);
                    res(i,9)=res(i,9)+d*sin(2.*alpha);
                end
            end
        end
    end
    
end

%-------------------------------------------------------------------------

function foncResult=fonc(b,c,z)

v2=0.5*b*z/c;
foncResult=1.0+v2;
n=2.0;
while(abs(v2)>0.00001)
    v2=v2*z*(0.5+n-1.)*(b+n-1.)/(n*(c+n-1.));
    foncResult=foncResult+v2;
    n=n+1.;
end
