function [a1,c1,a2,b2,c2,d2,a3,b3,c3,d3,a4,b4,c4,d4,w2]=...
    const2(m,e1,e2,e3,e4,e5,u1,u2,u3,u4,u5,z1,z2,z3,z4,pr);

m71=zeros(4,4);
m8=zeros(4,2);
m8(:,1)=[-1. 1. 1. -1.]';

m51=zeros(4,4);
m52=zeros(4,4);
m51(3,:)=[ 1.  -1.  1.  -1. ];
m52(4,:)=[-1.  -1.  1.   1. ];

m61=zeros(4,4);
m62=zeros(4,2);
m61(1:2,1)=[1.  1.]';
m62(1:2,1)=[1. -1.]';

m41=zeros(2,4);
m42=zeros(2,4);
m41(:,1)=[1.  1.]';
m42(:,2)=[1. -1.]';

jw=e4*(1+u5)/(e5*(1+u4));
delta=1./(-jw*jw*(3-4*u5)-2*jw*(5-6*u4-6*u5+8*u4*u5)-(3-4*u4));
m71(3,1)=jw*jw*(3-4*u5)+jw;
m71(3,2)=-m71(3,1);
m71(3,3)=m71(3,1)/jw;
m71(3,4)=-m71(3,3);

c2x=.0;    c2y=.0; 
c2z=.0;    c2t=.0;    
ctz2=.0;   cty2=.0;
cyx2=.0;   czy2=.0;
cx=.0;     ct=.0;
cz=.0;     ct=.0;
c4x=0.;    cyx4=0.;
c3x=0.;    cyx=0.;
cyx3=0.;   ctz=0.;
cty=0.;    czy=0.;

w2=0;

fw=e1*(1.+u2)/(e2*(1.+u1));
kw=e2*(1.+u3)/(e3*(1.+u2));
lw=e3*(1.+u4)/(e4*(1.+u3));

x=m*z1;
y=m*z2;
z=m*z3;
t=m*z4;

if(abs(-2.*x)< 20.0) c2x=exp(-2.*x); end;
if(abs(-2.*y)< 20.0) c2y=exp(-2.*y); end;
if(abs(-2.*z)< 20.0) c2z=exp(-2.*z); end;
if(abs(-2.*t)< 20.0) c2t=exp(-2.*t); end;

if(abs(-2.*(t-z))< 20.0) ctz2=exp(-2.*(t-z)); end;
if(abs(-2.*(t-y))< 20.0) cty2=exp(-2.*(t-y)); end;
if(abs(-2.*(z-y))< 20.0) czy2=exp(-2.*(z-y)); end;
if(abs(-2.*(y-x))< 20.0) cyx2=exp(-2.*(y-x)); end;

if(abs(-x)< 20.0) cx=exp(-x); end;
if(abs(-t)< 20.0) ct=exp(-t); end;
if(abs(-3.*x)< 20.0) c3x=exp(-3.*x); end;
if(abs(-4.*x)< 20.0) c4x=exp(-4.*x); end;

if(abs(-(t-z))< 20.0) ctz=exp(-(t-z)); end;
if(abs(-(t-y))< 20.0) cty=exp(-(t-y)); end;
if(abs(-(z-y))< 20.0) czy=exp(-(z-y)); end;

if(abs(-3.*(y-x))< 20.0) cyx3=exp(-3.*(y-x)); end;
if(abs(-(y-x))< 20.0)    cyx=exp(-(y-x));     end;
if(abs(-4.*(y-x))< 20.0) cyx4=exp(-4.*(y-x)); end;

l1=-2.*(1.-2.*u3)-(1.+lw);
l2=-2.*lw*(1.-2.*u4)-(1.+lw);
l3=0.5*(l1*(1.-4.*u4)-l2.*(1.-4.*u3));
k1=kw*(1.-u3)/(1.-u2);
f1=fw*(1.-u2)/(1.-u1);

m51(1,1)=-(1.+z);
m51(1,2)=-(2.-4.*u3-z);
m51(1,3)=-(2.*u3+z);
m51(1,4)=-(1.-2.*u3-z);
m52(2,1)=-(1.-z);
m52(2,2)=(2.-4.*u3+z);
m52(2,3)=(2.*u3-z);
m52(2,4)=-(1.-2.*u3+z);

m61(3,1)=lw;
m61(4,1)=lw;
m61(1,3)=-(1.-2.*u4-z);
m61(2,3)=2.*u4+z;
m61(3,3)=-lw*(2.-4.*u4-z);
m61(4,3)=lw*(1+z);
m62(3,1)=-lw;
m62(4,1)=lw;
m62(1,2)=(1.-2.*u4+z);
m62(2,2)=(2.*u4-z);
m62(3,2)=-lw*(2.-4.*u4+z);
m62(4,2)=-lw*(1.-z);

m8(1,2)=-(1.-2.*u4+t);
m8(2,2)=-2.*u4+t;
m8(3,2)=2.-4.*u4+t;
m8(4,2)=1.-t;

m71(1,1)=-jw*jw*(t+2.*u4)*(3.-4.*u5)-jw*((1.-2.*u5)*(3.-4.*u4)+1.+t);
m71(1,2)=-jw*jw*(1.-2.*u4-t)*(3.-4.*u5)-jw*(2.*(1.-u5)*(3.-4.*u4)-1.-t);
m71(1,3)=jw*(1.-2.*u5-(t+2.*u4)*(3.-4.*u5))-1.-t;
m71(1,4)=-jw*(2.*(1.-u5)-(t+2.*u4)*(3.-4.*u5))-2.+4.*u4+t;

rr1=1.+4.*x*c2x-c4x;
rr2=2.*(1.-x)*c3x-2.*(1.+x)*cx;
dd1=2.*(1.+2.*x*x)*c2x-c4x-1.;
rr3=f1*dd1/rr1;

qq1=2.*(2.*y-2.*x+rr3)*cyx2+1.-rr3-(1.+rr3)*cyx4;
qq2=2.*rr2*((1.+y-x)*cyx-(1.-y+x)*cyx3)/rr1;
dd2=2.*(1.+2.*(y-x)*(y-x))*cyx2+4.*rr3*(y-x)*cyx2;
dd2=dd2-(1.+rr3)*cyx4-1.+rr3;
qq3=k1*dd2/qq1;

m41(1,3)=-1.+2.*u3+y-qq3;
m41(2,3)=2.*u3+y;
m42(1,4)=1.-2.*u3+y-qq3;
m42(2,4)=2.*u3-y;

m79=m71*m8;
m78=delta*m79;
m6178=m61*m78;
m5161=m51*m6178;
m5162=m51*m62;
m5261=m52*m6178;
m5262=m52*m62;

n1=m41*m5161;
n2=m41*m5162;
n3=m42*m5261;
n4=m42*m5262;
n1=cty2*n1;
n2=czy2*n2;
n3=ctz2*n3;
ma=n1+n2+n3;

dd3=(ma(1,1)+n4(1,1))*ma(2,2)-(ma(1,2)+n4(1,2))*ma(2,1);
dd3=dd3+l1*l2*(1-qq3)+ma(1,1)*n4(2,2)-ma(1,2)*n4(2,1);

% --- IN FACT   B4E-Y    D4E-Y   ---
b4=4*(1-u3)*qq2*(ma(2,2)+n4(2,2))/qq1/dd3;
d4=-4*(1-u3)*qq2*(ma(2,1)+n4(2,1))/qq1/dd3;

% --- IN FACT   A3EZ    B3E-Y    C3EZ    D3E-Y   ---
a3=-((m5161(1,1)*ctz*cty+m5162(1,1)*czy)*b4);
a3=(a3-(m5161(1,2)*ctz*cty+m5162(1,2)*czy)*d4)/(4*(1-u3));
b3=-((m5261(2,1)*ctz2+m5262(2,1))*b4);
b3=(b3-(m5261(2,2)*ctz2+m5262(2,2))*d4)/(4*(1-u3));
c3=-((m5161(3,1)*ctz*cty+m5162(3,1)*czy)*b4);
c3=(c3-(m5161(3,2)*ctz*cty+m5162(3,2)*czy)*d4)/(4*(1-u3));
d3=-((m5261(4,1)*ctz2+m5262(4,1))*b4);
d3=(d3-(m5261(4,2)*ctz2+m5262(4,2))*d4)/(4*(1-u3));

% --- IN FACT  A2EY     B2E-X     C2EY       D2E-X   ---
aa3=a3*czy+b3-c3*(1-2*u3-y)*czy+d3*(1-2*u3+y);
c2=aa3*((2*y-2*x+rr3-1)*cyx2+1-rr3);
c2=(c2+rr2*((1+2*y-2*x)*cyx-cyx3)/rr1)/dd2;
d2=aa3*((1+2*y-2*x+rr3)*cyx-(1+rr3)*cyx3);
d2=(d2+rr2*(1-(1-2*y+2*x)*cyx2)/rr1)/dd2;
a2=0.5*(aa3+c2*(1-4*u2-2*y)-d2*cyx);
b2=0.5*(-rr2/rr1+c2*(1+rr3)*cyx-d2*(1-4*u2+2*x-rr3));

% --- IN FACT   A1EX    C1EX     D1E-X   ---
aa2=a2*cyx+b2-c2*(1-2*u2-x)*cyx+d2*(1-2*u2+x);
c1=(aa2*((2*x-1)*c2x+1)-(1+2*x)*cx+c3x)/dd1;
d1=(aa2*((1+2*x)*c2x-c4x)+(1-2*x)*c3x-cx)/dd1;
a1=0.5*(aa2+c1*(1-4*u1-2*x)-d1);

% --- IN FACT   A4ET   B4E-Z    C4ET   D4E-Z   ---
a4=cty*(m78(1,1)*b4+m78(1,2)*d4);
c4=cty*(m78(3,1)*b4+m78(3,2)*d4);
b4=b4*czy;
d4=d4*czy;

if(abs(a1)> pr|abs(c1)> pr) w2=1; end;
if(abs(a2)> pr|abs(b2)> pr|abs(c2)> pr |abs(d2)> pr) w2=1; end;
if(abs(a3)> pr|abs(b3)> pr|abs(c3)> pr |abs(d3)> pr) w2=1; end;
if(abs(b4)> pr|abs(d4)> pr) w2=1; end;

