
function couc1(i,j,z,p,a,j0,j1,j2,z1,u1,m,a1,c1,r,alpha);

% function for stress computation at the 1st layer

global prov;

x1=0.;
x2=0.;

if(abs(-m*(z1-z))<20.0)
    x1=exp(-m*(z1-z)); 
end
if(abs(-m*(z1+z))<20.0)
    x2=exp(-m*(z1+z)); 
end

b=a1*x1-(2.-4.*u1-m*z)*c1*x1+a1*(3.-4.*u1+2.*m*z)*x2-...
    c1*(2.-8.*u1*(1-u1)+m*z*(1-4.*u1))*x2;
prov(i,1)=prov(i,1)+p(j)*a(j)*j0*j1(j)*b/m;

b=a1*x1+c1*(1.+4.*u1+m*z)*x1+a1*(3.+4.*u1-2.*m*z)*x2-...
    c1*(1.-4.*u1*(1+2.*u1)-m*z*(1-4.*u1))*x2;
c=p(j)*a(j)*j0*j1(j)*b*(-1./2.);

if(r~=0.);
    b=a1*x1+c1*(1.+m*z)*x1+a1*(3.-4.*u1-2.*m*z)*x2-...
        c1*(1.-8.*u1*(1.-u1)-m*z*(1.-4.*u1))*x2;
    d=p(j)*a(j)*j1(j)*(j0/2-j2/(m*r))*b*(-1.);
    prov(i,4)=prov(i,4)+c+d*cos(2.*alpha);
    prov(i,5)=prov(i,5)+c-d*cos(2.*alpha);
    prov(i,9)=prov(i,9)+d*sin(2.*alpha);
    c=p(j)*a(j)*j2*j1(j)*b/m;
    prov(i,2)=prov(i,2)+c*cos(alpha);
    prov(i,3)=prov(i,3)+c*sin(alpha);
    b=a1*x1+c1*(2.*u1+m*z)*x1-a1*(1.-2.*m.*z)*x2-c1*(2.*u1+m*z-...
        4.*u1*m*z)*x2;
    c=p(j)*a(j)*j2*j1(j)*b*(-1.);
    prov(i,8)=prov(i,8)+c*cos(alpha);
    prov(i,7)=prov(i,7)+c*sin(alpha);
else
    prov(i,4)=prov(i,4)+c;
    prov(i,5)=prov(i,5)+c;
end

b=a1*x1-c1*(1.-2.*u1-m*z)*x1-a1*(1.+2.*m*z)*x2+...
    c1*(1.-2.*u1+m*z-4.*u1*m*z)*x2;
prov(i,6)=prov(i,6)+p(j)*a(j)*j0*j1(j)*b;


