
function surface(i,j,z1,a1,c1,u1,j0,j1,j2,m,p,a,r,alpha);

%  stresses computation at surface

global prov;

x1=0.;
if(abs(-m*z1)<20.0)
    x1=exp(-m*z1); 
end

prov(i,1)=prov(i,1)+p(j)*a(j)*j0*j1(j)*(a1-(1.-2.*u1)*c1)*x1/m;
c=p(j)*a(j)*j0*j1(j)*(a1+2.*u1*c1)*x1*(-2.*(1.+u1));

if(r~=0.)
    d=p(j)*a(j)*j1(j)*(a1+2*u1*c1)*x1*(j0-2*j2/(m*r))*(-2*(1.-u1));
    prov(i,4)=prov(i,4)+c+d*cos(2.*alpha);
    prov(i,5)=prov(i,5)+c-d*cos(2.*alpha);
    prov(i,9)=prov(i,9)+d*sin(2.*alpha);
    c=p(j)*a(j)*j2*j1(j)*(a1+2.*u1*c1)*x1/m;
    prov(i,2)=prov(i,2)+c*cos(alpha);
    prov(i,3)=prov(i,3)+c*sin(alpha);
else
    prov(i,4)=prov(i,4)+c;
    prov(i,5)=prov(i,5)+c;
end

