function [D1 m]=creep_parameters(mixparam,maat,Tref,time,z)

% Creep compliance mastercurve parameters

% Constants

lambda=0.4;

% inputs in creep parameters estimation

p34=mixparam(1); p38=mixparam(2); p4=mixparam(3); p200=mixparam(4); 
Va=mixparam(5); Vbeff=mixparam(6); A=mixparam(7); VTS=mixparam(8);

% Dynamic modulus mater curve parameters 

% delta=;
% alpha=;  

 gama=0.37217;


% Calculate aged viscosity

Vaged=agingf(A,VTS,Tref,maat,time,z);
beta=-0.513574-0.355353*log10(Vaged);


% Creep compliance parameters
% D0=;
D1=(10^(-log10(lambda) - delta-alpha/(1 + exp(beta)))-D0)*9; % from psi to Gpa
% temp=;
m=alpha*gama*temp/((1 + temp).^2)+0.408/(log10(log10(Vaged*10^8)));


end



    
