
function couc2(i,j,z,p,a,j0,j1,j2,z1,z2,u2,e2,m,a2,b2,c2,d2,r,alpha)

% function for stress computation at the 2nd layer

global prov;

y1=0.;
y2=0.;

if(abs(-m*(z2-z))<20.0)
    y1=exp(-m*(z2-z)); 
end
if(abs(-m*(z-z1))<20.0)
    y2=exp(-m*(z-z1)); 
end

b=a2*y1-b2*y2-c2*(2.-4.*u2-m*z)*y1-d2*(2.-4.*u2+m*z)*y2;
prov(i,1)=prov(i,1)+(1.+u2)*p(j)*a(j)*j0*j1(j)*b/(m*e2);

b=a2*y1+b2*y2+c2*(1.+4.*u2+m*z)*y1-d2*(1.+4.*u2-m*z)*y2;
c=-p(j)*a(j)*j0*j1(j)*b/2.;

if(r ~= 0.)
    b=a2*y1+b2*y2+c2*(1.+m*z)*y1-d2*(1.-m*z)*y2;
    d=p(j)*a(j)*j1(j)*b*(j2/(m*r)-j0/2);
    prov(i,4)=prov(i,4)+c+d*cos(2.*alpha);
    prov(i,5)=prov(i,5)+c-d*cos(2.*alpha);
    prov(i,9)=prov(i,9)+d*sin(2.*alpha);
    c=-(1.+u2)*p(j)*a(j)*j2*j1(j)*b/(m*e2);
    prov(i,2)=prov(i,2)+c*cos(alpha);
    prov(i,3)=prov(i,3)+c*sin(alpha);
    b=a2*y1-b2*y2+c2*(2.*u2+m*z)*y1+d2*(2.*u2-m*z)*y2;
    c=-p(j)*a(j)*j2*j1(j)*b;
    prov(i,8)=prov(i,8)+c*cos(alpha);
    prov(i,7)=prov(i,7)+c*sin(alpha);
else
    prov(i,4)=prov(i,4)+c;
    prov(i,5)=prov(i,5)+c;
end

b=a2*y1+b2*y2-c2*(1.-2.*u2-m*z)*y1+d2*(1.-2.*u2+m*z)*y2;
prov(i,6)=prov(i,6)+p(j)*a(j)*j0*j1(j)*b;

