
function couc3(i,j,z,p,a,j0,j1,j2,z2,z3,u3,e3,m,a3,b3,c3,d3,r,alpha)

% function for stress computation at the 3rd layer

global prov;

z5=0.;
z6=0.;

if(abs(-m*(z3-z))<20.0)
    z5=exp(-m*(z3-z)); 
end
if(abs(-m*(z-z2))<20.0)
    z6=exp(-m*(z-z2)); 
end

b=a3*z5-b3*z6-c3*(2.-4.*u3-m*z)*z5-d3*(2.-4.*u3+m*z)*z6;
prov(i,1)=prov(i,1)+(1.+u3)*p(j)*a(j)*j0*j1(j)*b/(m*e3);

b=a3*z5+b3*z6+c3*(1.+4.*u3+m*z)*z5-d3*(1.+4.*u3-m*z)*z6;
c=-p(j)*a(j)*j0*j1(j)*b/2.;

if(r~=0.)
    b=a3*z5+b3*z6+c3*(1.+m*z)*z5-d3*(1.-m*z)*z6;
    d=p(j)*a(j)*j1(j)*b*(j2/(m*r)-j0/2);
    prov(i,4)=prov(i,4)+c+d*cos(2.*alpha);
    prov(i,5)=prov(i,5)+c-d*cos(2.*alpha);
    prov(i,9)=prov(i,9)+d*sin(2.*alpha);
    c=-(1.+u3)*p(j)*a(j)*j2*j1(j)*b/(m*e3);
    prov(i,2)=prov(i,2)+c*cos(alpha);
    prov(i,3)=prov(i,3)+c*sin(alpha);
    b=a3*z5-b3*z6+c3*(2.*u3+m*z).*z5+d3*(2.*u3-m*z)*z6;
    c=-p(j)*a(j)*j2*j1(j)*b;
    prov(i,8)=prov(i,8)+c*cos(alpha);
    prov(i,7)=prov(i,7)+c*sin(alpha);
else
    prov(i,4)=prov(i,4)+c;
    prov(i,5)=prov(i,5)+c;
end

b=a3*z5+b3*z6-c3*(1.-2.*u3-m*z)*z5+d3*(1.-2.*u3+m*z)*z6;
prov(i,6)=prov(i,6)+p(j)*a(j)*j0*j1(j)*b;
