
% function for results printing

function results=imres(l1,ls,u1,u2,u3,u4,e1,e2,e3,e4,p1);

global res

results=zeros(l1,19);

for  i=1:l1
    
    for  j=1:6
        results(i,j)=res(i,j+3);
    end
    
    i1=res(i,4)+res(i,5)+res(i,6);
    
    if(abs(i1)>=0.00001 | res(i,6)>=0.00001)
    
        i2=res(i,4)*res(i,5)+res(i,5)*res(i,6)-res(i,9)^2;
        i2=i2+res(i,6)*res(i,4)-res(i,7)^2-res(i,8)^2;
        i3=res(i,4)*res(i,5)*res(i,6);
        i3=i3+2.*res(i,7)*res(i,8)*res(i,9);
        i3=i3-res(i,4)*res(i,7)^2-res(i,5)*res(i,8)^2;
        i3=i3-res(i,6)*res(i,9)^2;
        d=(3.*i2-i1*i1)/3.;

        if(d <0.)
            b=(9.*i1*i2-2.*i1^3-27.*i3)/27.;
            c=3.*b/(2.*d*sqrt(-d/3.));
            if(c < -1.);  c=-1.;  end;
            if(c > 1.);   c=1.;   end;
            teta1=acos(c)/3.;
            s1=2.*sqrt(-d/3.)*cos(teta1)+i1/3.;
            s2=2.*sqrt(-d/3.)*cos(teta1+2*pi/3)+i1/3.;
            s3=2.*sqrt(-d/3.)*cos(teta1+4*pi/3)+i1/3.;
            if(s1 <= s2)
                if(s2 <= s3);   s=s3;   s3=s1;   s1=s;
                else
                    if(s1 <= s3) 
                        s=s2;   s2=s3;  s3=s1;   s1=s;
                    else
                        s=s2;   s2=s1;  s1=s;
                    end
                end
            else
                if(s2 <= s3)
                    if(s1 <= s3)
                        s=s3;   s3=s2;  s2=s1;   s1=s;
                    else
                        s=s2;   s2=s3;  s3=s;
                    end
                end
            end
        else
            s1=res(i,4);   
            s2=res(i,5);
            s3=res(i,6);
        end
        
        if(ls(i)== 1);   u=u1;   e=e1;   end;
        if(ls(i)== 2);   u=u2;   e=e2;   end;
        if(ls(i)== 3);   u=u3;   e=e3;   end;
        if(ls(i)== 4);   u=u4;   e=e4;   end;
        
        eps1=(s1-u*(s2+s3))/e;
        eps2=(s2-u*(s1+s3))/e;
        eps3=(s3-u*(s1+s2))/e;

    else
        
        s1=0.;    s2=0.;    s3=0.;
        eps1=0.;  eps2=0.;  eps3=0.;      
        
    end

    results(i,7)=s1;
    results(i,8)=s2;
    results(i,9)=s3;
    results(i,10)=eps1;
    results(i,11)=eps2;
    results(i,12)=eps3;

    if(ls(i)== 1);   u=u1;   e=e1;   end;
    if(ls(i)== 2);   u=u2;   e=e2;   end;
    if(ls(i)== 3);   u=u3;   e=e3;   end;
    if(ls(i)== 4);   u=u4;   e=e4;   end;

    ez=(res(i,6)-u*(res(i,4)+res(i,5)))/e;
    ex=(res(i,4)-u*(res(i,5)+res(i,6)))/e;
    ey=(res(i,5)-u*(res(i,4)+res(i,6)))/e;
    results(i,13)=res(i,2);
    results(i,14)=res(i,3);
    results(i,15)=res(i,1);
    results(i,16)=ex;
    results(i,17)=ey;
    results(i,18)=ez;
    results(i,19)=p1;

end


