function [l1 ls l p a xc yc xs ys irqst]=load_setup(k)


% SINGLE AXLE
if (k==1)
    
    % Number of points to evaluate
    l1=2;
    
    % Layer for evaluation
    ls(1:2)=2;
    
    % Weight (pounds) (25kN)
    Lm=5620;
    
    
    % No. of contact-points (Dual tire)
    
    l=2;
    
    % Tire preassure psi (800 kPa)
    p(1:2)=116;
    
    % Contact areas sq.in.
    a(1:2)=(Lm/(pi*p(1)))^.5;
    
    % Wheel-coordinates (dual wheel center to center 12 inch)
    xc(1)=0; xc(2)=0;
    yc(1)=0; yc(2)=12;
    
    % Evaluation coordinates (z coordinate is set below as a function of
    % AC-thickness)
    
    zs=zeros(1:2);
    xs(1)=0; xs(2)=0;
    ys(1)=0; ys(2)=12;
    
    
    
    % Stresses as output
    irqst=1;
   
end
end